//
// Created by Falko Alrik Schmidt on 20.09.23.
//

#include "Ulm_Logger.h"

void Ulm_Logger::begin(unsigned long baud) {
    Serial.begin(baud);
    delay(2000);        // Let USB settle.
}

void Ulm_Logger::printError(const String& str) {
    Ulm_Logger::printColored(Ulm_ANSI::TextColor::RED, "FAIL", str);
}


String Ulm_Logger::ansiToString(Ulm_ANSI::TextColor color) {
    return String("\u001b[") + color + "m";
}

void Ulm_Logger::printColored(Ulm_ANSI::TextColor color, const String& msgType, const String& msg) {
    Serial.print('[');
    Serial.print(ansiToString(color));
    Serial.print(msgType);
    Serial.print(ansiToString(Ulm_ANSI::TextColor::RESET));
    Serial.print("] ");
    Serial.print(ansiToString(color));
    Serial.print(msg);
    Serial.println(ansiToString(Ulm_ANSI::TextColor::RESET));
}

void Ulm_Logger::printInformation(const String &str) {
    Ulm_Logger::printColored(Ulm_ANSI::TextColor::RESET, "INFO", str);
}

void Ulm_Logger::printWarning(const String &str) {
    Ulm_Logger::printColored(Ulm_ANSI::TextColor::YELLOW, "WARN", str);
}

void Ulm_Logger::printSuccess(const String &str) {
    Ulm_Logger::printColored(Ulm_ANSI::TextColor::GREEN, " OK ", str);
}
