//
// Created by Falko Alrik Schmidt on 20.09.23.
//

#ifndef UULM_WEATHERBALOON_ARDUINO_FRAMEWORK_TEST_ULM_LOGGER_H
#define UULM_WEATHERBALOON_ARDUINO_FRAMEWORK_TEST_ULM_LOGGER_H


#include <Arduino.h>

namespace Ulm_ANSI {
    typedef enum TextColor {
        BLACK = 30,
        RED = 31,
        GREEN = 32,
        YELLOW = 33,
        BLUE = 34,
        MAGENTA = 35,
        CYAN = 36,
        WHITE = 37,
        RESET = 0
    };
}

class Ulm_Logger {

public:
    static void begin(unsigned long baud = 115200);

    static void printError(const String &str);

    static void printInformation(const String &str);

    static void printWarning(const String &str);

    static void printSuccess(const String &str);

private:
    static inline String ansiToString(enum Ulm_ANSI::TextColor color);

    static void printColored(enum Ulm_ANSI::TextColor color, const String &msgType, const String &msg);

};


#endif //UULM_WEATHERBALOON_ARDUINO_FRAMEWORK_TEST_ULM_LOGGER_H
